/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.TipoConvenio;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoConvenio;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Shiro
 */
@Controller("busquedaTipoConvenioController")
@Scope("prototype")
public class BusquedaTipoConvenioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoConvenio> plwTipoConvenio;
    private MyListbox tConvenioList;
    private Paging pagingTipoConvenio;
    private Textbox txtNombre;

    public Paging getPagingTipoConvenio() {
        return pagingTipoConvenio;
    }

    public void setPagingTipoConvenio(Paging pagingTipoConvenio) {
        this.pagingTipoConvenio = pagingTipoConvenio;
    }

    public PagedListWrapper<TipoConvenio> getPlwTipoConvenio() {
        return plwTipoConvenio;
    }

    public void setPlwTipoConvenio(PagedListWrapper<TipoConvenio> plwTipoConvenio) {
        this.plwTipoConvenio = plwTipoConvenio;
    }

    public MyListbox gettConvenioList() {
        return tConvenioList;
    }

    public void settConvenioList(MyListbox tConvenioList) {
        this.tConvenioList = tConvenioList;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoConvenio(new TipoConvenio());

    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tConvenioList.setItemRenderer(new RenderTipoConvenio());
        tConvenioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoConvenio tc = (TipoConvenio) tConvenioList.getSelected();
                verTipoConvenio(tc);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verTipoConvenio(TipoConvenio tc) {
        if (tc == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tc", tc);
        args.put("tConvenioList", tConvenioList);

        openWindow("/gui/catalogos/editarTipoConvenio.zul",
                Labels.getLabel("busquedaTipoConvenioController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TipoConvenio> claseServicioBusqueda =
                new HibernateSearchObject<TipoConvenio>(TipoConvenio.class, pagingTipoConvenio.getPageSize());

        claseServicioBusqueda.addFilterLike("descTipo", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
        claseServicioBusqueda.addFilterNotEqual("tipoConvenioID", -1);
        claseServicioBusqueda.addSortAsc("descTipo");

        plwTipoConvenio.init(claseServicioBusqueda, tConvenioList, pagingTipoConvenio);
    }
}
